Skip to main content
`Ctrl`+`K`

# DSVectors

Compute vectors associated to the dense system such as eigenvectors.

## Synopsis

    #include "slepcds.h"
    PetscErrorCode DSVectors(DS ds,DSMatType mat,PetscInt *j,PetscReal *rnorm)

Logically Collective

## Input Parameters

- ds - the direct solver context

- mat - the matrix, used to indicate which vectors are required

## Input/Output Parameter

- j - (optional) index of vector to be computed

## Output Parameter

- rnorm - (optional) computed residual norm

## Notes

Allowed values for mat are `DS_MAT_X`, `DS_MAT_Y`, `DS_MAT_U` and `DS_MAT_V`, to compute right or left eigenvectors, or left or right singular vectors, respectively.

If `NULL` is passed in argument `j` then all vectors are computed, otherwise `j` indicates which vector must be computed. In real non-symmetric problems, on exit the index `j` will be incremented when a complex conjugate pair is found.

This function can be invoked after the dense problem has been solved, to get the residual norm estimate of the associated Ritz pair. In that case, the relevant information is returned in `rnorm`.

For computing eigenvectors, LAPACK’s `_trevc` is used so the matrix must be in (quasi-)triangular form, or call `DSSolve()` first.

## See Also

DS: Direct Solver (or Dense System), `DSSolve()`

## Level

intermediate

## Location

src/sys/classes/ds/interface/dsops.c

## Implementations

DSVectors_GHEP() in src/sys/classes/ds/impls/ghep/dsghep.c
DSVectors_GHIEP() in src/sys/classes/ds/impls/ghiep/dsghiep.c
DSVectors_GNHEP() in src/sys/classes/ds/impls/gnhep/dsgnhep.c
DSVectors_GSVD() in src/sys/classes/ds/impls/gsvd/dsgsvd.c
DSVectors_HEP() in src/sys/classes/ds/impls/hep/dshep.c
DSVectors_HSVD() in src/sys/classes/ds/impls/hsvd/dshsvd.c
DSVectors_NEP() in src/sys/classes/ds/impls/nep/dsnep.c
DSVectors_NHEP() in src/sys/classes/ds/impls/nhep/dsnhep.c
DSVectors_NHEPTS() in src/sys/classes/ds/impls/nhepts/dsnhepts.c
DSVectors_PEP() in src/sys/classes/ds/impls/pep/dspep.c
DSVectors_SVD() in src/sys/classes/ds/impls/svd/dssvd.c

Index of all DS routines Table of Contents for all manual pages Index of all manual pages